
import os
from multiprocessing import Pool

import random
import time

# script_template = "python run_pb.py -N {} -K {} -p linear -f full -o ../logs/linear/full -e 20000 --sigma 0.1 -t 0.01"

def run_experiment_full(arg):
    time.sleep(0.1 + random.random() * 10)

    command = f"""python run_utd.py -N {arg["N"]} --utd_data ../utd_models.pkl -f full -o {arg["output"]} -e {arg["epochs"]} --sigma {arg["sigma"]} -t {arg["tau"]} --seed {arg["seed"]}"""
    os.system(command)
    # print(command)
    return

args = []
Ns = [20, 50, 100, 200, 500, 1000]

for seed in range(5):
    output_file = "logs/full/utd/players/"
    for n in Ns:
        args.append({"N": n, "output":output_file, "epochs":50000, "sigma":0.1, "tau":"auto", "seed":seed})


with Pool(100) as p:
    p.map(run_experiment_full, args)

# run_experiment_full(args[0])